import 'package:json_annotation/json_annotation.dart';

part 'profile.g.dart';

abstract class Profile {
  final String id;
  final String userId;
  final String name;
  final String profilePic;
  final List<SocialProvider> providers;

  Profile(this.id, this.userId, this.name, this.profilePic, this.providers);
}

@JsonSerializable(explicitToJson: true)
class SocialProvider {
  final Map metadata;
  final String provider;
  final String id;

  SocialProvider(this.metadata, this.provider, this.id);

  SocialProvider.named({this.metadata, this.provider, this.id});

  Map<String, dynamic> toJson() => _$SocialProviderToJson(this);

  factory SocialProvider.fromJson(json) => _$SocialProviderFromJson(json);
}
